TextField (Solr 3.6.2 API)
Keywords: org.apache.solr.schema.TextField class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.schema
Class TextField

    java.lang.Object
      org.apache.solr.schema.FieldProperties
          org.apache.solr.schema.FieldType
              org.apache.solr.schema.TextField

    public class TextField

extends FieldType

`TextField` is the basic type for configurable text analysis. Analyzers for field types using this implementation should be defined in the schema.

Version:
  $Id: TextField.java 1302805 2012-03-20 09:11:54Z rmuir $

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.solr.schema.FieldType
`FieldType.DefaultAnalyzer`

Field Summary
`protected boolean` | `autoGeneratePhraseQueries`
`protected Analyzer` | `multiTermAnalyzer` Analyzer set by schema for text types to use when searching fields of this type, subclasses can set analyzer themselves or override getAnalyzer() This analyzer is used to process wildcard, prefix, regex and other multiterm queries.

Fields inherited from class org.apache.solr.schema.FieldType
`analyzer, args, falseProperties, log, POLY_FIELD_SEPARATOR, queryAnalyzer, trueProperties, typeName`

Fields inherited from class org.apache.solr.schema.FieldProperties
`BINARY, INDEXED, MULTIVALUED, OMIT_NORMS, OMIT_POSITIONS, OMIT_TF_POSITIONS, REQUIRED, SORT_MISSING_FIRST, SORT_MISSING_LAST, STORE_TERMOFFSETS, STORE_TERMPOSITIONS, STORE_TERMVECTORS, STORED, TOKENIZED`

Constructor Summary
`TextField()`

Method Summary
`String` | `analyzeMultiTerm(String field, String part, Analyzer analyzerIn)`
`boolean` | `getAutoGeneratePhraseQueries()`
`Query` | `getFieldQuery(QParser parser, SchemaField field, String externalVal)` Returns a Query instance for doing searches against a field.
`Analyzer` | `getMultiTermAnalyzer()` Returns the Analyzer to be used when searching fields of this type when mult-term queries are specified.
`Query` | `getRangeQuery(QParser parser, SchemaField field, String part1, String part2, boolean minInclusive, boolean maxInclusive)` Returns a Query instance for doing range searches on this field type.
`SortField` | `getSortField(SchemaField field, boolean reverse)` Returns the SortField instance that should be used to sort fields of this type.
`protected void` | `init(IndexSchema schema, Map<String,String> args)` subclasses should initialize themselves with the args provided and remove valid arguments.
`void` | `setAnalyzer(Analyzer analyzer)` Sets the Analyzer to be used when indexing fields of this type.
`void` | `setMultiTermAnalyzer(Analyzer analyzer)`
`void` | `setQueryAnalyzer(Analyzer analyzer)` Sets the Analyzer to be used when querying fields of this type.
`void` | `write(TextResponseWriter writer, String name, Fieldable f)` calls back to TextResponseWriter to write the field value
`void` | `write(XMLWriter xmlWriter, String name, Fieldable f)` Renders the specified field as XML

Methods inherited from class org.apache.solr.schema.FieldType
`createField, createField, createFields, getAnalyzer, getArg, getFieldIndex, getFieldStore, getFieldTermVec, getIndexOptions, getQueryAnalyzer, getStringSort, getTypeName, getValueSource, getValueSource, hasProperty, indexedToReadable, isMultiValued, isPolyField, isTokenized, multiValuedFieldCache, readableToIndexed, restrictProps, storedToIndexed, storedToReadable, toExternal, toInternal, toObject, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### autoGeneratePhraseQueries

    protected boolean autoGeneratePhraseQueries

### multiTermAnalyzer

    protected Analyzer multiTermAnalyzer

  Analyzer set by schema for text types to use when searching fields of this type, subclasses can set analyzer themselves or override getAnalyzer() This analyzer is used to process wildcard, prefix, regex and other multiterm queries. It assembles a list of tokenizer +filters that "make sense" for this, primarily accent folding and lowercasing filters, and charfilters.

  See Also:
    `getMultiTermAnalyzer()`, `setMultiTermAnalyzer(org.apache.lucene.analysis.Analyzer)`

Constructor Detail

### TextField

    public TextField()

Method Detail

### init

    protected void init(IndexSchema schema,
                        Map<String,String> args)

  Description copied from class: `FieldType`
  subclasses should initialize themselves with the args provided and remove valid arguments. leftover arguments will cause an exception. Common boolean properties have already been handled.

  Overrides:
    `init` in class `FieldType`

### getMultiTermAnalyzer

    public Analyzer getMultiTermAnalyzer()

  Returns the Analyzer to be used when searching fields of this type when mult-term queries are specified.

  This method may be called many times, at any time.

  See Also:
    `FieldType.getAnalyzer()`

### setMultiTermAnalyzer

    public void setMultiTermAnalyzer(Analyzer analyzer)

### getAutoGeneratePhraseQueries

    public boolean getAutoGeneratePhraseQueries()

### getSortField

    public SortField getSortField(SchemaField field,
                                  boolean reverse)

  Description copied from class: `FieldType`
  Returns the SortField instance that should be used to sort fields of this type.

  Specified by:
    `getSortField` in class `FieldType`
  See Also:
    `SchemaField.checkSortability()`

### write

    public void write(XMLWriter xmlWriter,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  Renders the specified field as XML

  Specified by:
    `write` in class `FieldType`
  Throws:
    `IOException`

### write

    public void write(TextResponseWriter writer,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  calls back to TextResponseWriter to write the field value

  Specified by:
    `write` in class `FieldType`
  Throws:
    `IOException`

### getFieldQuery

    public Query getFieldQuery(QParser parser,
                               SchemaField field,
                               String externalVal)

  Description copied from class: `FieldType`
  Returns a Query instance for doing searches against a field.

  Overrides:
    `getFieldQuery` in class `FieldType`
  Parameters:
    `parser` - The `QParser` calling the method
    `field` - The `SchemaField` of the field to search
    `externalVal` - The String representation of the value to search
  Returns:
    The `Query` instance. This implementation returns a `TermQuery` but overriding queries may not

### setAnalyzer

    public void setAnalyzer(Analyzer analyzer)

  Description copied from class: `FieldType`
  Sets the Analyzer to be used when indexing fields of this type.

  The default implementation throws a SolrException. Subclasses that override this method need to ensure the behavior of the analyzer is consistent with the implementation of toInternal.

  Overrides:
    `setAnalyzer` in class `FieldType`
  See Also:
    `FieldType.toInternal(java.lang.String)`, `FieldType.setQueryAnalyzer(org.apache.lucene.analysis.Analyzer)`, `FieldType.getAnalyzer()`

### setQueryAnalyzer

    public void setQueryAnalyzer(Analyzer analyzer)

  Description copied from class: `FieldType`
  Sets the Analyzer to be used when querying fields of this type.

  The default implementation throws a SolrException. Subclasses that override this method need to ensure the behavior of the analyzer is consistent with the implementation of toInternal.

  Overrides:
    `setQueryAnalyzer` in class `FieldType`
  See Also:
    `FieldType.toInternal(java.lang.String)`, `FieldType.setAnalyzer(org.apache.lucene.analysis.Analyzer)`, `FieldType.getQueryAnalyzer()`

### getRangeQuery

    public Query getRangeQuery(QParser parser,
                               SchemaField field,
                               String part1,
                               String part2,
                               boolean minInclusive,
                               boolean maxInclusive)

  Description copied from class: `FieldType`
  Returns a Query instance for doing range searches on this field type. `SolrQueryParser` currently passes part1 and part2 as null if they are '*' respectively. minInclusive and maxInclusive are both true currently by SolrQueryParser but that may change in the future. Also, other QueryParser implementations may have different semantics.

  Sub-classes should override this method to provide their own range query implementation. They should strive to handle nulls in part1 and/or part2 as well as unequal minInclusive and maxInclusive parameters gracefully.

  Overrides:
    `getRangeQuery` in class `FieldType`
    `field` - the schema field
    `part1` - the lower boundary of the range, nulls are allowed.
    `part2` - the upper boundary of the range, nulls are allowed
    `minInclusive` - whether the minimum of the range is inclusive or not
    `maxInclusive` - whether the maximum of the range is inclusive or not
  Returns:
    a Query instance to perform range search according to given parameters
  See Also:
    `SolrQueryParser.getRangeQuery(String, String, String, boolean)`

### analyzeMultiTerm

    public String analyzeMultiTerm(String field,
                                   String part,
                                   Analyzer analyzerIn)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD